UVALive 4730 线段树+并查集

点击打开链接

题意:在坐标上给n个点,r的操作是将两个点连起来,l的操作是问你y=u的这条线连接的集合块数和这些集合内的点的个数

思路:很麻烦的一道题,在网上看了题意和做法后,开始了一下午的调bug过程,做法很好懂,我开了两个线段树,一个维护点代表的直线的集合个数,另一个则是路过集合内的点的个数,然后集合的判断直接用并查集就行了,这是两个核心,然后就是自己瞎写的了,代码丑的可以而且好像除了本人别人看着可能要骂人了,有兴趣研究的可以留言我来解答,那难的部分其实就是并查集合并时该怎么将这两个要维护的值弄进线段树中,而且这题我用的离散化处理的,好像可以不用,但感觉空间上有点过意不去,所以代码看着真是丑,然后说说合并的操作,先是集合的个数,令左边上下限分别为L1,R1,右边上限是L2,R2,下面都是这样,然后L1到R1的集合个数全部减1,也就是区间更新,然后R1到R2也是一样,然后整个大区间+1,现在看若左边区间个数是1,右边也是1,那么合并后还是1,第二个线段树的操作与这个相似,统计一下就可以了,注意细节,这里献上九野聚聚的样例,也是这个样例终结了我一下午的找BUG旅程

  1. 3
  2. 11
  3. 1 7
  4. 5 7
  5. 8 6
  6. 3 5
  7. 5 5
  8. 2 3
  9. 10 3
  10. 7 2
  11. 4 1
  12. 11 1
  13. 4 6
  14. 21
  15. road 0 1
  16. road 3 5
  17. line 6.5
  18. road 4 2
  19. road 3 8
  20. road 4 7
  21. road 6 9
  22. road 4 1
  23. road 2 7
  24. line 4.5
  25. line 6.5
  26. line 3.5
  27. line 2.5
  28. line 5.5
  29. road 10 0
  30. line 5.5
  31. line 6.5
  32. road 0 3
  33. line 1.5
  34. line 6.5
  35. line 2.5
  36. ans:
  37. 0 0
  38. 2 8
  39. 1 5
  40. 2 8
  41. 3 10
  42. 1 5
  43. 1 6
  44. 1 6
  45. 2 11
  46. 1 9
  47. 2 11

再献上丑的可以的我的代码

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <iostream>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
const int inf=0x3f3f3f3f;
const ll INF=0x3f3f3f3f3f3f3f3fll;
const int maxn=100010;
int f[maxn*2],r[maxn*2],L[maxn*2],R[maxn*2],t[maxn*4],num2[maxn*8],num1[maxn*8],Q[maxn*2][2],Lazy1[maxn*8],Lazy2[maxn*8];
int len;
double pos1[maxn*2];
char ch[200010][10];
int find1(int x){
    if(x!=f[x]) f[x]=find1(f[x]);
    return f[x];
}
void pushdown_1(int node){
    if(Lazy1[node]){
        Lazy1[node<<1]+=Lazy1[node];
        Lazy1[node<<1|1]+=Lazy1[node];
        num1[node<<1]+=Lazy1[node];
        num1[node<<1|1]+=Lazy1[node];
        Lazy1[node]=0;
    }
}
void pushdown_2(int node){
    if(Lazy2[node]){
        Lazy2[node<<1]+=Lazy2[node];
        Lazy2[node<<1|1]+=Lazy2[node];
        num2[node<<1]+=Lazy2[node];
        num2[node<<1|1]+=Lazy2[node];
        Lazy2[node]=0;
    }
}
void buildtree(int le,int ri,int node){
    num2[node]=num1[node]=Lazy1[node]=Lazy2[node]=0;
    if(le==ri) return ;
    int t=(le+ri)>>1;
    buildtree(le,t,node<<1);
    buildtree(t+1,ri,node<<1|1);
}
void update_1(int l,int r,int x,int le,int ri,int node){
    if(l<=le&&ri<=r){
        Lazy1[node]+=x;
        num1[node]+=x;
        return ;
    }
    pushdown_1(node);
    int t=(le+ri)>>1;
    if(l<=t) update_1(l,r,x,le,t,node<<1);
    if(r>t) update_1(l,r,x,t+1,ri,node<<1|1);
}
void update_2(int l,int r,int x,int le,int ri,int node){
    if(l<=le&&ri<=r){
        Lazy2[node]+=x;
        num2[node]+=x;
        return ;
    }
    pushdown_2(node);
    int t=(le+ri)>>1;
    if(l<=t) update_2(l,r,x,le,t,node<<1);
    if(r>t) update_2(l,r,x,t+1,ri,node<<1|1);
}
int query_1(int pos,int le,int ri,int node){
    if(le==ri) return num1[node];
    pushdown_1(node);
    int t=(le+ri)>>1;
    int ans;
    if(pos<=t) ans=query_1(pos,le,t,node<<1);
    else ans=query_1(pos,t+1,ri,node<<1|1);
    return ans;
}
int query_2(int pos,int le,int ri,int node){
    if(le==ri) return num2[node];
    pushdown_2(node);
    int t=(le+ri)>>1;
    int ans;
    if(pos<=t) ans=query_2(pos,le,t,node<<1);
    else ans=query_2(pos,t+1,ri,node<<1|1);
    return ans;
}
void unite(int a,int b){
    int aa=find1(a);
    int bb=find1(b);
    if(aa==bb) return ;
    if(L[aa]>=L[bb]&&R[aa]<=R[bb]){
        int l1=lower_bound(t,t+len,L[aa])-t+1;
        int r1=lower_bound(t,t+len,R[aa])-t+1;
        int l2=lower_bound(t,t+len,L[bb])-t+1;
        int r2=lower_bound(t,t+len,R[bb])-t+1;
        update_1(l1,r1,-1,1,len,1);
        update_1(l2,r2,-1,1,len,1);
        update_1(l2,r2,1,1,len,1);
        update_2(l1,r1,-r[aa],1,len,1);
        update_2(l2,r2,-r[bb],1,len,1);
        update_2(l2,r2,r[aa]+r[bb],1,len,1);
    }else if(L[aa]>=L[bb]&&R[aa]>R[bb]){
        int l1=lower_bound(t,t+len,L[aa])-t+1;
        int r1=lower_bound(t,t+len,R[aa])-t+1;
        int l2=lower_bound(t,t+len,L[bb])-t+1;
        int r2=lower_bound(t,t+len,R[bb])-t+1;
        update_1(l1,r1,-1,1,len,1);
        update_1(l2,r2,-1,1,len,1);
        update_1(l2,r1,1,1,len,1);
        update_2(l1,r1,-r[aa],1,len,1);
        update_2(l2,r2,-r[bb],1,len,1);
        update_2(l2,r1,r[aa]+r[bb],1,len,1);
    }else if(L[aa]<L[bb]&&R[aa]<=R[bb]){
        int l1=lower_bound(t,t+len,L[aa])-t+1;
        int r1=lower_bound(t,t+len,R[aa])-t+1;
        int l2=lower_bound(t,t+len,L[bb])-t+1;
        int r2=lower_bound(t,t+len,R[bb])-t+1;
        update_1(l1,r1,-1,1,len,1);
        update_1(l2,r2,-1,1,len,1);
        update_1(l1,r2,1,1,len,1);
        update_2(l1,r1,-r[aa],1,len,1);
        update_2(l2,r2,-r[bb],1,len,1);
        update_2(l1,r2,r[aa]+r[bb],1,len,1);
    }else if(L[aa]<L[bb]&&R[aa]>R[bb]){
        int l1=lower_bound(t,t+len,L[aa])-t+1;
        int r1=lower_bound(t,t+len,R[aa])-t+1;
        int l2=lower_bound(t,t+len,L[bb])-t+1;
        int r2=lower_bound(t,t+len,R[bb])-t+1;
        update_1(l1,r1,-1,1,len,1);
        update_1(l2,r2,-1,1,len,1);
        update_1(l1,r1,1,1,len,1);
        update_2(l1,r1,-r[aa],1,len,1);
        update_2(l2,r2,-r[bb],1,len,1);
        update_2(l1,r1,r[aa]+r[bb],1,len,1);
    }
    f[aa]=bb;r[bb]+=r[aa];L[bb]=min(L[bb],L[aa]);R[bb]=max(R[bb],R[aa]);
}
struct edge{
    int x,y;
}id[maxn];
int main(){
    int T,n,m,u,v;
    scanf("%d",&T);
    while(T--){
        scanf("%d",&n);
        for(int i=0;i<n;i++) scanf("%d%d",&id[i].x,&id[i].y);
        int k=0;
        for(int i=0;i<n;i++){
            id[i].y*=2;
            f[i]=i;r[i]=1;t[k++]=id[i].y;L[i]=id[i].y;R[i]=id[i].y;
        }
        scanf("%d",&m);
        for(int i=0;i<m;i++){
            scanf("%s",ch[i]);
            if(ch[i][0]=='r') scanf("%d%d",&Q[i][0],&Q[i][1]);
            else if(ch[i][0]=='l'){
                scanf("%lf",&pos1[i]);
                Q[i][0]=(int)2*pos1[i];
                t[k++]=Q[i][0];
            }
        }
        sort(t,t+k);
        len=unique(t,t+k)-t;
        buildtree(1,len,1);
        for(int i=0;i<m;i++){
            if(ch[i][0]=='r') unite(Q[i][0],Q[i][1]);
            else if(ch[i][0]=='l'){
                int ll=lower_bound(t,t+len,Q[i][0])-t+1;
                int ans1=query_1(ll,1,len,1);
                int ans2=query_2(ll,1,len,1);
                printf("%d %d\n",ans1,ans2);
            }
        }
    }
    return 0;
}
时间: 2024-11-10 02:54:37

UVALive 4730 线段树+并查集的相关文章

UVALive 4730 Kingdom 线段树+并查集

题目链接:点击打开链接 题意见白书P248 思路: 先把读入的y值都扩大2倍变成整数 然后离散化一下 用线段树来维护y轴 区间上每个点的 城市数量和联通块数量, 然后用并查集维护每个联通块及联通块的最大最小y值,还要加并查集的秩来记录每个联通块的点数 然后就是模拟搞.. T^T绝杀失败题..似乎数组开小了一点就过了,== #include<stdio.h> #include<math.h> #include<vector> #include<string.h>

UVA 1455 - Kingdom(线段树+并查集)

UVA 1455 - Kingdom 题目链接 题意:给定一些城市坐标点,连在一起的城市称为一个州,现在用两种操作,road表示把城市a,b建一条路,line表示询问一个y轴上穿过多少个州,和这些州共包含多少个城市 思路:利用并查集维护每个州的上界和下界还有城市个数,然后每次加进一条路的时候,根据两个集合的位置可以处理出区间的州和城市数如何进行加减,然后利用线段树搞就可以了 代码: #include <cstdio> #include <cstring> #include <

(线段树+并查集) Codeforces Round #416 (Div. 2) E Vladik and Entertaining Flags

In his spare time Vladik estimates beauty of the flags. Every flag could be represented as the matrix n?×?m which consists of positive integers. Let's define the beauty of the flag as number of components in its matrix. We call component a set of cel

【BZOJ-3673&amp;3674】可持久化并查集 可持久化线段树 + 并查集

3673: 可持久化并查集 by zky Time Limit: 5 Sec  Memory Limit: 128 MBSubmit: 1878  Solved: 846[Submit][Status][Discuss] Description n个集合 m个操作操作:1 a b 合并a,b所在集合2 k 回到第k次操作之后的状态(查询算作操作)3 a b 询问a,b是否属于同一集合,是则输出1否则输出0 0<n,m<=2*10^4 Input Output Sample Input 5 6

【BZOJ 4662】 4662: Snow (线段树+并查集)

4662: Snow Time Limit: 40 Sec  Memory Limit: 256 MBSubmit: 136  Solved: 47 Description 2333年的某一天,临冬突降大雪,主干道已经被雪覆盖不能使用.城 主 囧·雪 决定要对主干道进行一次清扫. 临冬城的主干道可以看为一条数轴.囧·雪 一共找来了n个清理工,第 i个清理工的工作范围为[li,ri],也就是说这个清理工会把[li,ri]这一 段主干道清理干净(当然已经被清理过的部分就被忽略了).当然有可能主 干道

【Codeforces811E】Vladik and Entertaining Flags [线段树][并查集]

Vladik and Entertaining Flags Time Limit: 20 Sec  Memory Limit: 512 MB Description n * m的矩形,每个格子上有一个数字代表颜色. q次询问,询问[l, r]有几个连通块,若颜色相同并且连通则属于同一个连通块. Input 输入第一行n,m,q. 然后一个n*m的矩形. 之后q行,每行两个整数l,r. Output 输出q行,对于每个询问输出答案. Sample Input 4 5 4 1 1 1 1 1 1 2

【XSY2707】snow 线段树 并查集

题目描述 有\(n\)个人和一条长度为\(t\)的线段,每个人还有一个工作范围(是一个区间).最开始整条线段都是白的.定义每个人的工作长度是这个人的工作范围中白色部分的长度(会随着线段改变而改变).每一天开始时你要选择一个人满足这个人的工作长度最小(如果有多个就选编号最小的).把这个人的工作区间染黑.请你输出每天你选了哪个人. 保证工作范围中左端点和右端点单调递增. \(n\leq 300000\) 题解 先把线段离散化成很多个小区间,那么每个小区间只会被染黑一次(染黑之后不会变白). 因此每次

【CF687D】Dividing Kingdom II 线段树+并查集

[CF687D]Dividing Kingdom II 题意:给你一张n个点m条边的无向图,边有边权$w_i$.有q个询问,每次给出l r,问你:如果只保留编号在[l,r]中的边,你需要将所有点分成两个集合,使得这个划分的代价最小,问最小代价是什么.一个划分的代价是指,对于所有两端点在同一集合中的边,这些边的边权最大值.如果没有端点在同一集合中的边,则输出-1. $n,q\le 1000,m\le \frac {n(n-1)} 2,w_i\le 10^9$ 题解:先考虑暴力的做法,我们将所有边按

[CSP-S模拟测试]:Dash Speed(线段树+并查集+LCA)

题目描述 比特山是比特镇的飙车圣地.在比特山上一共有$n$个广场,编号依次为$1$到$n$,这些广场之间通过$n−1$条双向车道直接或间接地连接在一起,形成了一棵树的结构. 因为每条车道的修建时间以及建筑材料都不尽相同,所以可以用两个数字$l_i,r_i$量化地表示一条车道的承受区间,只有当汽车以不小于$l_i$且不大于$r_i$的速度经过这条车道时,才不会对路面造成伤害. $Byteasar$最近新买了一辆跑车,他想在比特山飙一次车.$Byteasar$计划选择两个不同的点$S,T$,然后在它